#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()


import code.functions.loading as loading


class BitWalker( pygame.sprite.Sprite ):

	def __init__( self, filename, bit_positions, changetime, chosen_bit,
		transparency_colorkey ):
		pygame.sprite.Sprite.__init__( self )

		self.bit_positions = bit_positions
		self.chosen_bit = chosen_bit
		self.current_bit = self.bit_positions[self.chosen_bit]
		self.bit_index = self.current_bit[0]
		
		self.transparency_colorkey = transparency_colorkey
		
		self.image = loading.load_image( filename )
		self.image.set_colorkey( self.transparency_colorkey )
		self.rect = self.image.get_rect( center = self.current_bit[1] )

		self.changetime = changetime
		self.counter = 0
		


	def update( self ):
		if self.counter >= self.changetime:
			self.counter = 0
			self.set_next_bit()
		else:
			self.counter += 1


	def set_next_bit( self ):
	
		if self.bit_index >= len( self.bit_positions ):
			self.chosen_bit = 0
		else:
			self.chosen_bit += 1

		self.current_bit = self.bit_positions[self.chosen_bit]
		self.bit_index = self.current_bit[0]
		self.rect.center = self.current_bit[1]
