#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()

from code.constants.constants import CHARACTERS


class Character( pygame.sprite.Sprite ):
	def __init__( self, character, foreground_color, background_color,
		transparency_color, top, left ):
		pygame.sprite.Sprite.__init__( self )

		character = CHARACTERS[character]

		width = height = len( character.splitlines() )

		self.image = pygame.Surface( ( width, height ) )
		self.rect = self.image.get_rect()
		self.rect.top = top
		self.rect.left = left

		character_lines = character.splitlines()

		row_counter = 0

		for row in character_lines:
			for col in range( len( row ) ):
				if row[col] == '#':
					color = foreground_color
				elif row[col] == ' ':
					color = background_color
					
				self.image.set_at( ( col, row_counter ), color )

			row_counter += 1


		self.image.set_colorkey( transparency_color )


	def update( self ):
		pass
