#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()


from code.classes.Option import Option
from code.classes.Sentence import Sentence


class Menu( object ):

	 def __init__( self, heading, options, chosen_option, chosen_option_color ):

	 	self.heading = Sentence( **heading )
	 	
	 	self.options = list()
	 	for x in range( len( options ) ):
	 		self.options.append( Option( options[x]["sentence_data"], chosen_option_color, x,
	 			options[x]["action"] ) )

	 	self.max_options = len( options )
	 	self.chosen_option = chosen_option


	 def update( self, events ):

	 	action = self.handle_keyboard_input( events )

	 	for x in self.options:
	 		if x.index == self.chosen_option and x.active == False:
	 			x.active = True
	 			x.activate()
	 		elif x.index != self.chosen_option and x.active == True:
	 			x.active = False
	 			x.deactivate()

	 	if action is not None:
	 		return action


	 def handle_keyboard_input( self, events ):

	 	action = None
	 	
	 	for e in events:
	 		if e.type == pygame.KEYDOWN:
	 			if e.key == pygame.K_DOWN and self.chosen_option < self.max_options - 1:
	 				self.chosen_option += 1

	 			if e.key == pygame.K_UP and self.chosen_option > 0:
	 				self.chosen_option -= 1


	 		if e.type == pygame.KEYDOWN and e.key == pygame.K_RETURN:
	 			for x in self.options:
	 				if x.index == self.chosen_option:
	 					action = x.action

	 	return action


	 def draw( self, window ):
	 
	 	self.heading.draw( window )
	 	
	 	for option in self.options:
	 		option.draw( window )
	 					
	 				
