#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()

from code.classes.Sentence import Sentence


class Option( object ):

	def __init__( self, sentence_data, chosen_color, index, action ):

		self.sentence_inactive = Sentence( **sentence_data )
		sentence_data["foreground_color"] = chosen_color
		self.sentence_active = Sentence( **sentence_data )

		self.index = index
		self.active = False
		self.action = action


	def activate( self ):
		self.active = True


	def deactivate( self ):
		self.active = False


	def draw( self, window ):
		if self.active:
			self.sentence_active.draw( window )
		else:
			self.sentence_inactive.draw( window )
