#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()

from code.classes.Word import Word
import code.constants.constants as constants


class Sentence( object ):

	def __init__( self, sentence, top = 0, left = 0,
		foreground_color = constants.WHITE, background_color = constants.BLACK,
		transparency_color = constants.BLACK, vertical_spacing = 9,
		horizontal_spacing = 9 ):

		self.sentence = sentence
		self.text = list()
		self.lines = self.sentence.splitlines()

		space_to_prepend = ""

		
		self.orig_left = left


		for l in self.lines:
			for w in l.split():
			
				# Append the word.
				word = Word( space_to_prepend + w, foreground_color, background_color,
					transparency_color, top, left, horizontal_spacing )
				self.text.append( word )

				left = word.new_left
				space_to_prepend = " "

			space_to_prepend = ""
			top += vertical_spacing
			left = self.orig_left


	def update( self ):
		pass


	def draw( self, window ):
	
		for w in self.text:
			for c in w.characters:
				window.blit( c.image, c.rect )
