#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()

import random


class TrashParticle( pygame.sprite.DirtySprite ):
	def __init__( self, surface, lefttop_position, time_to_live,
		original_horizontal_speed, original_vertical_speed ):
	
		pygame.sprite.Sprite.__init__( self )

		self.image = surface
		self.rect = self.image.get_rect()
		self.rect.left = lefttop_position[0]
		self.rect.top = lefttop_position[1]
		
		self.alpha = 255
		self.alpha_stepping = int( self.alpha / time_to_live )
		self.image.set_alpha( self.alpha )
		self.time_to_live = time_to_live
				
		self.image.set_alpha( self.alpha )

		self.original_horizontal_speed = random.randint( -1, 1 )#original_horizontal_speed
		self.original_vertical_speed = random.randint( 1, 3 ) #original_vertical_speed


	def update( self ):
	
		self.rect.move_ip( random.randint( -1, 1 ) + self.original_horizontal_speed,
			random.randint( -1, 1 ) + self.original_vertical_speed )
		self.alpha -= self.alpha_stepping
		self.image.set_alpha( self.alpha )		
		
		if self.time_to_live <= 0:
			self.kill()
		else:
			self.time_to_live -= 1
