#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pickle

import code.constants.constants as constants
from code.classes.Sentence import Sentence


def create_highscore():

	file_handle = open( constants.HIGHSCORE_FILE, "wb" )
	file_handle.close()


def read_highscore():

	file_handle = open( constants.HIGHSCORE_FILE, "rb" )
	highscore_list = pickle.load( file_handle )
	return highscore_list


def write_highscore( highscore_list ):

	file_handle = open( constants.HIGHSCORE_FILE, "wb" )
	pickle.dump( highscore_list, file_handle )
	file_handle.close()


def render_highscore( highscore_list, top = 0, left = 0 ):

	highscore_string = ""

	counter = 1
	for listing in highscore_list:
		highscore_string += "%s. %s - SCORE: %s\n" % (
			counter, listing[0], listing[1]
		)
		counter += 1

	return Sentence( highscore_string, top, left )


def sort_highscore( highscore_list ):

	return sorted( highscore_list, key=lambda x: x[1] )[::-1]
