#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
pygame.init()

import random
import math

from code.classes.TrashParticle import TrashParticle


def surface_to_particles( surface, top, left, transparency_colorkey,
	horizontal_speed = 0, vertical_speed = 0 ):

	particles = pygame.sprite.Group()

	if surface.get_width() % 5 == 0:
		width = surface.get_width()
	else:
		width = surface.get_width() - 1

	if surface.get_height() % 5 == 0:
		height = surface.get_height()
	else:
		height = surface.get_height() - 1


	for col in range( 0, width, 5 ):
		for row in range( 0, height, 5 ):
		
			 # Grab the colour of the next pixel.
			 pixel_color = surface.get_at( ( col, row ) )
			 pixel_top = top + row
			 pixel_left = left + col

			 # Create the surface.
			 pixel = surface.subsurface( pygame.Rect( col, row, random.randint( 1, 5 ), random.randint( 1, 5 ) ) ) #pygame.Surface( ( 5, 5 ) )
			 #pixel.fill( pixel_color )
			 pixel.set_colorkey( transparency_colorkey )

			 particles.add( TrashParticle( pixel, ( pixel_left, pixel_top ),
			 	random.randint( 5, 125 ), horizontal_speed, vertical_speed
			 ) )
			 
	return particles
