#    Deep Space - A space-shooting game.
#    Copyright (C) 2014  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


import copy
import random

import pygame
pygame.init()

from code.classes.EnemySpaceship import EnemySpaceship
import code.constants.constants as constants

def create_enemy_wave( wave_number ):

	enemies = pygame.sprite.Group()

	for x in range( wave_number ):
		enemy_data = copy.deepcopy( random.choice( ( constants.ENEMY_A,
			constants.ENEMY_B, constants.ENEMY_C, constants.ENEMY_D ) ) )

		enemy_data["action"] = random.choice( constants.ENEMY_MOVEMENTS )

		enemy_data["center_xy_position"] = ( random.randint( 15, 625 ), random.randint( -115, -50 ) )
		enemy_data["speed"] = random.randint( 1, 6 )
		enemy_data["delay"] = random.randint( 1, 250 )
			
		enemies.add( EnemySpaceship( **enemy_data ) )


	return enemies


def wave_completed( enemies ):

	if len( enemies ) == 0:
		return True
	return False


def next_wave( enemies, wave_number ):

	wave_number += 1
	return wave_number, create_enemy_wave( wave_number )
